# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

from types import ListType
from os import path as ospath
from xml.dom.minidom import parse as xml_parse
import os
import thread
from copy import deepcopy
import pickle
from xml.dom.minidom import getDOMImplementation
from xcore.utils import _safe_to_int
from django.conf import settings
TASKS = settings.TASKS
MODIFIABLE_PATH = settings.MODIFIABLE_PATH

def open_task(task, task_type):
    filepath = TASKS.getDirectory(task)
    filename = ''.join([
        filepath,
        ospath.sep,
        'structure.xml'])
    dom = xml_parse(filename)
    if dom.documentElement.tagName != task_type:
        raise Exception('Exercise not supported by ' + task_type)
    
    return dom


def task_cmp(x, y):
    
    try:
        xstring = '%3d' % int(x['task_volume']) + x['task_block'] + '%3d' % int(x['task_unit']) + '%3d' % int(x['task_number']) + x['task_name']
        ystring = '%3d' % int(y['task_volume']) + y['task_block'] + '%3d' % int(y['task_unit']) + '%3d' % int(y['task_number']) + y['task_name']
        return cmp(xstring, ystring)
    except:
        return 0



def get_sorted_task_data(manifest):
    tasks = find_tasks()
    ret = []
    
    try:
        
        try:
            for task, path in tasks:
                data = deepcopy(get_data_from_manifest(manifest, task))
                data['task'] = task
                data['task_id'] = task.split('_')[-1]
                ret.append(data)
        except Exception:
            e = None
            print e
            raise e

        ret.sort(cmp = task_cmp)
    except Exception:
        e = None
        print e
        raise e

    return ret


def get_data_from_manifest(manifest, id):
    if manifest.has_key(id):
        return manifest[id]
    else:
        return dict(task_name = '(Kein Name gefunden)', task_volume = '1', task_block = 'A', task_unit = '1', task_number = '1', task_type = u'')


def get_stored_task_information(xmlfile):
    ''' creates a manifest dict entry based on an task_id and the module/structure.xml '''
    
    try:
        dom = xml_parse(xmlfile)
        root = dom.documentElement
        task_name = root.getAttribute('name')
        task_volume = root.getAttribute('volume')
        task_block = root.getAttribute('block')
        task_unit = root.getAttribute('unit')
        task_number = root.getAttribute('number')
        task_type = root.nodeName
        task_approved = _safe_to_int(root.getAttribute('approved'), 0)
    except:
        return (u'(Kein Name gefunden)', u'1', u'A', u'1', u'1', u'', 0)

    return (task_name, task_volume, task_block, task_unit, task_number, task_type, task_approved)


def find_tasks():
    return TASKS.getItems()


def create_manifest(tasks = []):
    ''' recreates the manifest file (formerly namelist) from the available tasks '''
    manifest = dict()
    for task, path in tasks:
        (task_name, task_volume, task_block, task_unit, task_number, task_type, task_approved) = get_stored_task_information(ospath.join(path, 'structure.xml'))
        manifest[task] = dict(task_name = task_name, task_volume = task_volume, task_block = task_block, task_unit = task_unit, task_number = task_number, task_type = task_type, task_approved = task_approved)
    
    return manifest


def load_manifest():
    f = open(ospath.join(MODIFIABLE_PATH, 'manifest.dat'), 'r')
    manifest = pickle.load(f)
    f.close()
    return manifest


def write_manifest(manifest):
    
    try:
        f = open(ospath.join(MODIFIABLE_PATH, 'manifest.dat'), 'w')
        pickle.dump(manifest, f)
        f.close()
    except:
        pass



def update_manifest(task_id, manifest = None, task_name = u'(Kein Name vorhanden)', task_volume = u'1', task_block = u'A', task_unit = u'1', task_number = u'1', task_type = u'', task_approved = False):
    if manifest == None:
        
        try:
            manifest = load_manifest()
        manifest = dict()

    
    
    try:
        manifest['task_%04d' % int(task_id)] = dict(task_name = task_name, task_volume = task_volume, task_block = task_block, task_unit = task_unit, task_number = task_number, task_type = task_type, task_approved = task_approved)
    except:
        print 'Could not update manifest: ', task_id, task_name, task_volume, task_block, task_unit, task_number, task_type
        raise 

    return manifest

