# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

''' Views '''
from django.shortcuts import render_to_response
import utils
from django.views.decorators.cache import never_cache
from django.http import HttpResponseRedirect
from django.utils.decorators import decorator_from_middleware
from django.contrib.sessions.middleware import SessionMiddleware
from utils import open_task
import time

def view(request):
    
    try:
        manifest = utils.load_manifest()
    except:
        manifest = utils.create_manifest(utils.find_tasks())
        utils.write_manifest(manifest)

    return render_to_response('index.html', dict(get_sorted_task_data = utils.get_sorted_task_data(manifest)))

view = never_cache(view)

def preview_navframe(request, task_id, **kw):
    task_id = int(task_id)
    if 'status_message' in kw:
        status_message = kw['status_message']
    else:
        status_message = None
    preview_types_dict = {
        'type_free': None,
        'type_1st': None,
        'type_underline': None,
        'type_1stunderline': None,
        'type_dnd': None,
        'type_dropdown': None }
    dom = None
    if 'preview_types' in kw:
        preview_types = kw['preview_types']
    else:
        preview_types = ''
        dom = open_task('task_%04d' % task_id, 'gapfill')
        docEl = dom.documentElement
        for k in preview_types_dict.keys():
            if docEl.getAttribute(k) == 'true':
                if len(preview_types) == 0:
                    preview_types = k
                else:
                    preview_types = ','.join([
                        preview_types,
                        k])
            len(preview_types) == 0
        
    splitted = preview_types.split(',')
    for t in splitted:
        preview_types_dict[t] = True
    
    if 'current_preview_type' in kw:
        current_preview_type = kw['current_preview_type']
    elif dom is None:
        dom = self.open_task('task_%04d' % task_id, 'gapfill')
    
    current_preview_type = dom.documentElement.getAttribute('type_default')
    result = render_to_response('gapfill_preview_nav.html', dict(pretty_title = 'Gapfill Vorschau', preview_types = preview_types, preview_types_dict = preview_types_dict, status_message = '', task_id = task_id, task_editor = 'gapfill', current_preview_type = current_preview_type))
    request.session['task_%04d_level' % task_id] = 1
    return result

preview_navframe = decorator_from_middleware(SessionMiddleware)(preview_navframe)

def preview_previewframe(request, task_id, **kw):
    task_id = int(task_id)
    preview_type = request.GET['preview_type']
    preview_level = int(request.GET['preview_level'])
    request.session['task_%04d_level' % task_id] = preview_level
    request.session['task_%04d_type' % task_id] = preview_type
    return HttpResponseRedirect('/tasks/task_%04d/view/?force_no_cache=%s' % (task_id, time.time()))

preview_previewframe = decorator_from_middleware(SessionMiddleware)(preview_previewframe)
