# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

from django.http import HttpResponse
from django.utils import simplejson
from django.utils.decorators import decorator_from_middleware
from django.contrib.sessions.middleware import SessionMiddleware
import datetime
import os
import logging
from alexandriacore.utils import keys_to_byteString
from django.template import Template, RequestContext
from django.views.decorators.cache import never_cache
from types import ListType, TupleType
destination = 'CD-Rom'
genialmod_unit = 12
genialunit = 12
name = '\xc3\x9cbung 1'
number = 1
container = '12'
editor = 'sortitems'

def dispatch_media(request, module_type, media_id, **kwargs):
    static = request.ProjectSettings.STATIC
    return static.dispatch(request, media_id, key = module_type)

dispatch_media = never_cache(dispatch_media)

def render(request, module_type, **kwargs):
    if kwargs.has_key('exercise_id'):
        key = u'_'.join([
            request.ProjectName,
            kwargs['exercise_id'],
            'lvl'])
        if key in request.session.keys():
            kwargs['level'] = request.session[key]
        else:
            kwargs['level'] = 0
        key = u'_'.join([
            request.ProjectName,
            kwargs['exercise_id'],
            'alt'])
        if key in request.session.keys():
            kwargs['alt'] = request.session[key]
        else:
            kwargs['alt'] = 0
    
    
    try:
        kwargs['levels_available'] = request.session[u'_'.join([
            request.ProjectName,
            module_type,
            'levelcount'])] > 1
    except:
        kwargs['levels_available'] = False

    task_level = 1
    level_field = u'_'.join([
        request.ProjectName,
        module_type,
        'level'])
    type_field = u'_'.join([
        request.ProjectName,
        module_type,
        'type'])
    if level_field in request.session:
        task_level = int(request.session[level_field])
    
    level3_filename = os.path.join(os.path.split(__file__)[0], '..', 'static', request.session[type_field] + '_solution' + '.view')
    if task_level == 3 and os.path.exists(level3_filename):
        filename = level3_filename
    else:
        filename = os.path.join(os.path.split(__file__)[0], '..', 'static', request.session[type_field] + [
            '',
            '_hint'][task_level >= 2] + '.view')
    f = open(filename, 'r')
    result = f.read()
    f.close()
    if not kwargs.has_key('genialmod_unit'):
        kwargs['genialmod_unit'] = genialmod_unit
    
    if not kwargs.has_key('genialunit'):
        kwargs['genialunit'] = genialunit
    
    if not kwargs.has_key('name'):
        kwargs['name'] = name
    
    if not kwargs.has_key('number'):
        kwargs['number'] = number
    
    if not kwargs.has_key('skin'):
        kwargs['skin'] = 'skins/genial'
    
    if not kwargs.has_key('count'):
        kwargs['count'] = 1
    
    return HttpResponse(Template(result).render(RequestContext(request, keys_to_byteString(kwargs))))


def view(request, module_type, **kwargs):
    tmp = kwargs
    nkw = dict()
    for key, value in kwargs.iteritems():
        if isinstance(key, unicode):
            key = key.encode('utf-8')
        
        nkw[key] = value
    
    for key, value in request.GET.iteritems():
        x = value
        if x.upper() == 'TRUE':
            x = True
        elif x.upper() == 'FALSE':
            x = False
        else:
            
            try:
                x = int(x)
            except:
                pass

        if isinstance(key, unicode):
            key = key.encode('utf-8')
        
        nkw[key] = x
    
    nkw['comm_url'] = '../../communication/'
    nkw['feedback_url'] = '../../feedback/'
    return render(request, module_type, **nkw)

view = never_cache(view)
all_count = 8
corr_mapping = {
    0: {
        1: [
            {
                'srcs': [
                    4920],
                'type': 1 },
            {
                'srcs': [
                    4879],
                'type': 1 },
            {
                'srcs': [
                    4771],
                'type': 1 },
            {
                'srcs': [
                    2007],
                'type': 1 }],
        2: [
            {
                'srcs': [
                    1490],
                'type': 1 },
            {
                'srcs': [
                    239],
                'type': 1 },
            {
                'srcs': [
                    3994],
                'type': 1 },
            {
                'srcs': [
                    2901],
                'type': 1 }] } }
str_mappings = {
    u'Entschuldigen Sie, das war mein Fehler.': 3994,
    u'Verzeihen Sie bitte, kann ich Ihnen helfen?': 4879,
    u'Entschuldigung, das wollte ich nicht.': 239,
    u'Darf ich Sie etwas fragen, bitte?': 2007,
    u'Das tut mir wirklich sehr leid.': 1490,
    u'Verzeihung, das ist mir sehr peinlich.': 2901,
    u'Entschuldigung, ist der Platz hier noch frei?': 4920,
    u'Sag mal, hast du hier eine Tasche gesehen?': 4771 }

def validate_mixed(request, module_type, **kw):
    gap_id = request.POST['gap_id']
    tmp_gap_id = request.POST['gap_id']
    return HttpResponse(simplejson.dumps(dict(gap_id = tmp_gap_id, result = 'WhoCares', ensure_ascii = False)))


def validate_id(request, module_type, **kw):
    level_field = u'_'.join([
        request.ProjectName,
        module_type,
        'level'])
    type_field = u'_'.join([
        request.ProjectName,
        module_type,
        'type'])
    target_id = int(request.POST['target_id'].split('_')[-1])
    tmp_target_id = request.POST['target_id']
    entry_id = int(request.POST['entry_id'])
    already_here = _[1]
    level = int(request.session[level_field])
    page_id = int(request.POST['page_id'])
    if 'preview' in request.session[type_field]:
        if page_id % 2 == 0:
            return HttpResponse(simplejson.dumps(dict(target_id = tmp_target_id, entry_id = entry_id, result = 'WhoCares', ensure_ascii = False)))
        else:
            page_id = page_id / 2
    
    result = 'WRONG'
    mappings = corr_mapping[page_id][target_id]
    for mapping in mappings:
        if entry_id in mapping['srcs']:
            tmp_data = mapping['srcs'][:]
            tmp_data.remove(entry_id)
            result = 'OK'
            for data in tmp_data:
                if data in already_here:
                    result = 'WRONG'
                    break
                    continue
            
            break
            continue
    
    return HttpResponse(simplejson.dumps(dict(target_id = tmp_target_id, entry_id = entry_id, result = result, ensure_ascii = False)))


def get_hint(request, module_type, **kw):
    type_field = u'_'.join([
        request.ProjectName,
        module_type,
        'type'])
    level_field = u'_'.join([
        request.ProjectName,
        module_type,
        'level'])
    page_id = int(request.POST['page_id'])
    if 'preview' in request.session[type_field]:
        if page_id % 2 == 0:
            return HttpResponse(simplejson.dumps(dict(), ensure_ascii = False))
        else:
            page_id = page_id / 2
    
    source_id = int(request.POST['source_id'])
    level = int(request.session[level_field])
    if level != 3:
        return HttpResponse(simplejson.dumps(dict(), ensure_ascii = False))
    
    targets = []
    equivalent = []
    for target, corr_ids in corr_mapping[page_id].iteritems():
        for corr_id in corr_ids:
            if source_id in corr_id['srcs']:
                equivalent = corr_id['srcs']
                targets += [
                    target]
                continue
        
    
    return HttpResponse(simplejson.dumps(dict(targets = targets, equivalent = equivalent), ensure_ascii = False))

get_hint = never_cache(get_hint)

def evaluate_form_id(request, module_type, **kw):
    type_field = u'_'.join([
        request.ProjectName,
        module_type,
        'type'])
    correct_field = u'_'.join([
        request.ProjectName,
        module_type,
        'correct'])
    result = []
    page_id = int(request.POST['page_id'])
    if 'preview' in request.session[type_field]:
        if page_id % 2 == 0:
            return HttpResponse(simplejson.dumps(dict(complete = True, results = []), ensure_ascii = False))
        else:
            page_id = page_id / 2
    
    false_or_missing = False
    if correct_field in request.session:
        correct = request.session[correct_field]
        if len(correct) != len(corr_mapping.keys()):
            correct = { }
            for id in corr_mapping.keys():
                correct[id] = {
                    'corrcnt': 0,
                    'item_ids': [] }
            
        
    else:
        correct = { }
        for id in corr_mapping.keys():
            correct[id] = {
                'corrcnt': 0,
                'item_ids': [] }
        
    mycorr = 0
    corr_items = []
    for target, corr_ids in corr_mapping[page_id].iteritems():
        target_id = 'sort_%d' % target
        if target_id not in request.POST:
            false_or_missing = True
            result += [
                {
                    't_id': target_id,
                    'result': False }]
            continue
        received_ids = request.POST[target_id]
        received_ids = received_ids.split(',')
        received_ids = filter((lambda x: x != ''), received_ids)
        found_state_list = [ {
            'ids': x['srcs'],
            'found': False } for x in corr_ids ]
        this_target_ok = True
        for received_id in received_ids:
            item_result = False
            
            try:
                for found_state in found_state_list:
                    if int(received_id) in found_state['ids']:
                        pass
                    item_result = found_state['found'] == False
                    if item_result:
                        found_state['found'] = True
                        mycorr = mycorr + 1
                        corr_items += [
                            {
                                't_id': target_id,
                                'i_id': received_id }]
                        break
                        continue
                    []
            except KeyError:
                []
                e = []
                []
            except:
                []

            result += [
                {
                    't_id': target_id,
                    'i_id': received_id,
                    'result': item_result }]
        
        if not reduce((lambda g, h: if g:
passh['found']), found_state_list, True):
            false_or_missing = True
            this_target_ok = False
        
        result += [
            {
                't_id': target_id,
                'result': this_target_ok }]
    
    correct[page_id]['corrcnt'] = mycorr
    correct[page_id]['item_ids'] = corr_items
    request.session[correct_field] = correct
    corr_count = 0
    for key, value in correct.iteritems():
        if key <= page_id:
            corr_count += value['corrcnt']
            continue
    
    if all_count == 0:
        feedback_percent = 100
    else:
        feedback_percent = 100 * float(corr_count) / all_count
    return HttpResponse(simplejson.dumps(dict(feedback_percent = feedback_percent, complete = not false_or_missing, results = result), ensure_ascii = False))

evaluate_form_id = never_cache(evaluate_form_id)

def reset_task(request, module_type, **kw):
    correct_field = u'_'.join([
        request.ProjectName,
        module_type,
        'correct'])
    correct = { }
    for id in corr_mapping.keys():
        correct[id] = {
            'corrcnt': 0,
            'item_ids': [] }
    
    request.session[correct_field] = correct
    return HttpResponse(simplejson.dumps(dict(result = 'OK'), ensure_ascii = False))

reset_task = never_cache(reset_task)

def get_correct(request, module_type, **kw):
    correct_field = u'_'.join([
        request.ProjectName,
        module_type,
        'correct'])
    page_id = int(request.POST['page_id'])
    if correct_field in request.session:
        correct = request.session[correct_field]
        if len(correct) != len(corr_mapping.keys()):
            correct = { }
            for id in corr_mapping.keys():
                correct[id] = {
                    'corrcnt': 0,
                    'item_ids': [] }
            
        
    else:
        correct = { }
        for id in corr_mapping.keys():
            correct[id] = {
                'corrcnt': 0,
                'item_ids': [] }
        
    res = []
    if page_id in correct.keys():
        res = correct[page_id]['item_ids']
    
    return HttpResponse(simplejson.dumps(dict(page_id = page_id, items = res), ensure_ascii = False))

get_correct = never_cache(get_correct)
