# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

from django.http import HttpResponse
from django.utils import simplejson
from django.utils.decorators import decorator_from_middleware
from django.contrib.sessions.middleware import SessionMiddleware
import datetime
import os
import logging
from alexandriacore.utils import keys_to_byteString
from django.template import Template, RequestContext
from django.views.decorators.cache import never_cache
from types import ListType, TupleType
destination = 'CD-Rom'
genialmod_unit = 1
genialunit = 1
name = '\xc3\x9cbung 7'
number = 1
container = '1'
editor = 'memory'

def dispatch_media(request, module_type, media_id, **kwargs):
    static = request.ProjectSettings.STATIC
    return static.dispatch(request, media_id, key = module_type)

dispatch_media = never_cache(dispatch_media)

def render(request, module_type, **kwargs):
    if kwargs.has_key('exercise_id'):
        key = u'_'.join([
            request.ProjectName,
            kwargs['exercise_id'],
            'lvl'])
        if key in request.session.keys():
            kwargs['level'] = request.session[key]
        else:
            kwargs['level'] = 0
        key = u'_'.join([
            request.ProjectName,
            kwargs['exercise_id'],
            'alt'])
        if key in request.session.keys():
            kwargs['alt'] = request.session[key]
        else:
            kwargs['alt'] = 0
    
    
    try:
        kwargs['levels_available'] = request.session[u'_'.join([
            request.ProjectName,
            module_type,
            'levelcount'])] > 1
    except:
        kwargs['levels_available'] = False

    task_level = 1
    level_field = u'_'.join([
        request.ProjectName,
        module_type,
        'level'])
    type_field = u'_'.join([
        request.ProjectName,
        module_type,
        'type'])
    if level_field in request.session:
        task_level = int(request.session[level_field])
    
    level3_filename = os.path.join(os.path.split(__file__)[0], '..', 'static', request.session[type_field] + '_solution' + '.view')
    if task_level == 3 and os.path.exists(level3_filename):
        filename = level3_filename
    else:
        filename = os.path.join(os.path.split(__file__)[0], '..', 'static', request.session[type_field] + [
            '',
            '_hint'][task_level >= 2] + '.view')
    f = open(filename, 'r')
    result = f.read()
    f.close()
    if not kwargs.has_key('genialmod_unit'):
        kwargs['genialmod_unit'] = genialmod_unit
    
    if not kwargs.has_key('genialunit'):
        kwargs['genialunit'] = genialunit
    
    if not kwargs.has_key('name'):
        kwargs['name'] = name
    
    if not kwargs.has_key('number'):
        kwargs['number'] = number
    
    if not kwargs.has_key('skin'):
        kwargs['skin'] = 'skins/genial'
    
    if not kwargs.has_key('count'):
        kwargs['count'] = 1
    
    return HttpResponse(Template(result).render(RequestContext(request, keys_to_byteString(kwargs))))


def view(request, module_type, **kwargs):
    tmp = kwargs
    nkw = dict()
    for key, value in kwargs.iteritems():
        if isinstance(key, unicode):
            key = key.encode('utf-8')
        
        nkw[key] = value
    
    for key, value in request.GET.iteritems():
        x = value
        if x.upper() == 'TRUE':
            x = True
        elif x.upper() == 'FALSE':
            x = False
        else:
            
            try:
                x = int(x)
            except:
                pass

        if isinstance(key, unicode):
            key = key.encode('utf-8')
        
        nkw[key] = x
    
    nkw['comm_url'] = '../../communication/'
    nkw['feedback_url'] = '../../feedback/'
    return render(request, module_type, **nkw)

view = never_cache(view)
corr_mappings = {
    0: [
        (4852, 4520),
        (4057, 2117),
        (650, 2100),
        (2377, 4974),
        (2388, 2083),
        (1559, 3223),
        (791, 2730),
        (2114, 2947),
        (2269, 3762),
        (4807, 2590)] }

def validate_pair(request, module_type, **kw):
    item1 = int(request.POST['pair_item_1'])
    item2 = int(request.POST['pair_item_2'])
    page = int(request.POST['page'])
    if item1 == item2:
        return HttpResponse(simplejson.dumps(dict(pair_item_1 = item1, pair_item_2 = item2, result = False), ensure_ascii = False))
    
    pairs = corr_mappings[page]
    for pair in pairs:
        if item1 in pair and item2 in pair:
            return HttpResponse(simplejson.dumps(dict(pair_item_1 = item1, pair_item_2 = item2, result = True), ensure_ascii = False))
            continue
    
    return HttpResponse(simplejson.dumps(dict(pair_item_1 = item1, pair_item_2 = item2, result = False), ensure_ascii = False))


def get_hint(request, module_type, **kw):
    level_field = u'_'.join([
        request.ProjectName,
        module_type,
        'level'])
    level = int(request.session[level_field])
    page = int(request.POST['page'])
    item = int(request.POST['item'])
    if level != 2:
        return HttpResponse(simplejson.dumps(dict(result = False), ensure_ascii = False))
    
    pairs = corr_mappings[page]
    for pair in pairs:
        if item in pair:
            other = pair[item == pair[0]]
            return HttpResponse(simplejson.dumps(dict(item = item, other = other, result = True), ensure_ascii = False))
            continue
    
    return HttpResponse(simplejson.dumps(dict(result = False), ensure_ascii = False))


def reset_task(request, module_type, **kw):
    correct_field = u'_'.join([
        request.ProjectName,
        module_type,
        'correct'])
    correct = [ { } for i in range(0, len(corr_mappings)) ]
    request.session[correct_field] = correct
    return HttpResponse(simplejson.dumps(dict(result = 'OK'), ensure_ascii = False))

reset_task = never_cache(reset_task)

def store_page(request, module_type, **kw):
    correct_field = u'_'.join([
        request.ProjectName,
        module_type,
        'correct'])
    page_id = int(request.POST['page_id'])
    pairs = int(request.POST['pairs'])
    flipped = request.POST['flipped']
    correct[page_id]['flipped'] = flipped
    correct[page_id]['pairs'] = pairs
    request.session[correct_field] = correct
    corr_count = 0
    for page in correct:
        if 'pairs' in page:
            corr_count = corr_count + page['pairs']
            continue
        [] if correct_field in request.session else []
    
    all_count = 0
    for mapping in corr_mappings.values():
        all_count = all_count + len(mapping)
    
    if all_count == 0:
        feedback_percent == 100
    else:
        feedback_percent = 100 * float(corr_count) / all_count
    return HttpResponse(simplejson.dumps(dict(feedback_percent = feedback_percent, result = 'OK'), ensure_ascii = False))

store_page = never_cache(store_page)

def get_correct(request, module_type, **kw):
    correct_field = u'_'.join([
        request.ProjectName,
        module_type,
        'correct'])
    page_id = int(request.POST['page_id'])
    correct = correct[page_id]
    if len(correct.keys()) != 2:
        correct = {
            'flipped': 0,
            'pairs': '' }
    
    return HttpResponse(simplejson.dumps(correct, ensure_ascii = False))

