# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

from django.http import HttpResponse
from django.utils import simplejson
from django.utils.decorators import decorator_from_middleware
from django.contrib.sessions.middleware import SessionMiddleware
import datetime
import os
import logging
from alexandriacore.utils import keys_to_byteString
from django.template import Template, RequestContext
from django.views.decorators.cache import never_cache
from types import ListType, TupleType
destination = 'CD-Rom'
genialmod_unit = 6
genialunit = 6
name = '\xc3\x9cbung 1'
number = 1
container = '6'
editor = 'wordsearch'

def dispatch_media(request, module_type, media_id, **kwargs):
    static = request.ProjectSettings.STATIC
    return static.dispatch(request, media_id, key = module_type)

dispatch_media = never_cache(dispatch_media)

def render(request, module_type, **kwargs):
    if kwargs.has_key('exercise_id'):
        key = u'_'.join([
            request.ProjectName,
            kwargs['exercise_id'],
            'lvl'])
        if key in request.session.keys():
            kwargs['level'] = request.session[key]
        else:
            kwargs['level'] = 0
        key = u'_'.join([
            request.ProjectName,
            kwargs['exercise_id'],
            'alt'])
        if key in request.session.keys():
            kwargs['alt'] = request.session[key]
        else:
            kwargs['alt'] = 0
    
    
    try:
        kwargs['levels_available'] = request.session[u'_'.join([
            request.ProjectName,
            module_type,
            'levelcount'])] > 1
    except:
        kwargs['levels_available'] = False

    task_level = 1
    level_field = u'_'.join([
        request.ProjectName,
        module_type,
        'level'])
    type_field = u'_'.join([
        request.ProjectName,
        module_type,
        'type'])
    if level_field in request.session:
        task_level = int(request.session[level_field])
    
    level3_filename = os.path.join(os.path.split(__file__)[0], '..', 'static', request.session[type_field] + '_solution' + '.view')
    if task_level == 3 and os.path.exists(level3_filename):
        filename = level3_filename
    else:
        filename = os.path.join(os.path.split(__file__)[0], '..', 'static', request.session[type_field] + [
            '',
            '_hint'][task_level >= 2] + '.view')
    f = open(filename, 'r')
    result = f.read()
    f.close()
    if not kwargs.has_key('genialmod_unit'):
        kwargs['genialmod_unit'] = genialmod_unit
    
    if not kwargs.has_key('genialunit'):
        kwargs['genialunit'] = genialunit
    
    if not kwargs.has_key('name'):
        kwargs['name'] = name
    
    if not kwargs.has_key('number'):
        kwargs['number'] = number
    
    if not kwargs.has_key('skin'):
        kwargs['skin'] = 'skins/genial'
    
    if not kwargs.has_key('count'):
        kwargs['count'] = 1
    
    return HttpResponse(Template(result).render(RequestContext(request, keys_to_byteString(kwargs))))


def view(request, module_type, **kwargs):
    tmp = kwargs
    nkw = dict()
    for key, value in kwargs.iteritems():
        if isinstance(key, unicode):
            key = key.encode('utf-8')
        
        nkw[key] = value
    
    for key, value in request.GET.iteritems():
        x = value
        if x.upper() == 'TRUE':
            x = True
        elif x.upper() == 'FALSE':
            x = False
        else:
            
            try:
                x = int(x)
            except:
                pass

        if isinstance(key, unicode):
            key = key.encode('utf-8')
        
        nkw[key] = x
    
    nkw['comm_url'] = '../../communication/'
    nkw['feedback_url'] = '../../feedback/'
    return render(request, module_type, **nkw)

view = never_cache(view)
wordsearch_mappings = [
    [
        {
            u'PARLAMENT': {
                'px': 9,
                'py': 3,
                'direction': 1,
                'len': 9 },
            u'KAISER': {
                'px': 14,
                'py': 3,
                'direction': 1,
                'len': 6 },
            u'KANZLER': {
                'px': 3,
                'py': 1,
                'direction': 1,
                'len': 7 },
            u'WELTKRIEG': {
                'px': 11,
                'py': 1,
                'direction': 0,
                'len': 9 },
            u'DIKTATUR': {
                'px': 4,
                'py': 11,
                'direction': 0,
                'len': 8 },
            u'WAHLRECHT': {
                'px': 11,
                'py': 1,
                'direction': 1,
                'len': 9 },
            u'PROTEST': {
                'px': 7,
                'py': 5,
                'direction': 1,
                'len': 7 },
            u'MONARCHIE': {
                'px': 6,
                'py': 7,
                'direction': 0,
                'len': 9 },
            u'REICHSTAG': {
                'px': 18,
                'py': 0,
                'direction': 1,
                'len': 9 },
            u'REPUBLIK': {
                'px': 16,
                'py': 1,
                'direction': 1,
                'len': 8 } }]]
wordsearch_fields = [
    [
        [
            [
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                True,
                False],
            [
                False,
                False,
                False,
                True,
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                True,
                True,
                True,
                True,
                True,
                True,
                True,
                True,
                True],
            [
                False,
                False,
                False,
                True,
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                True,
                False,
                False,
                False,
                False,
                True,
                False,
                True,
                False],
            [
                False,
                False,
                False,
                True,
                False,
                False,
                False,
                False,
                False,
                True,
                False,
                True,
                False,
                False,
                True,
                False,
                True,
                False,
                True,
                False],
            [
                False,
                False,
                False,
                True,
                False,
                False,
                False,
                False,
                False,
                True,
                False,
                True,
                False,
                False,
                True,
                False,
                True,
                False,
                True,
                False],
            [
                False,
                False,
                False,
                True,
                False,
                False,
                False,
                True,
                False,
                True,
                False,
                True,
                False,
                False,
                True,
                False,
                True,
                False,
                True,
                False],
            [
                False,
                False,
                False,
                True,
                False,
                False,
                False,
                True,
                False,
                True,
                False,
                True,
                False,
                False,
                True,
                False,
                True,
                False,
                True,
                False],
            [
                False,
                False,
                False,
                True,
                False,
                False,
                True,
                True,
                True,
                True,
                True,
                True,
                True,
                True,
                True,
                False,
                True,
                False,
                True,
                False],
            [
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                True,
                False,
                True,
                False,
                True,
                False,
                False,
                True,
                False,
                True,
                False,
                True,
                False],
            [
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                True,
                False,
                True,
                False,
                True,
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                False],
            [
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                True,
                False,
                True,
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                False],
            [
                False,
                False,
                False,
                False,
                True,
                True,
                True,
                True,
                True,
                True,
                True,
                True,
                False,
                False,
                False,
                False,
                False,
                False,
                False,
                False]]]]

def _calc_feedback_percentage(corr, mapping):
    all_points = 0
    corr_points = 0
    for cpage, mpage in zip(corr, mapping):
        for cblock, mblock in zip(cpage['blocks'], mpage):
            for k in mblock.keys():
                all_points += 1
                if k in cblock:
                    corr_points += 1
                    continue
            
        
    
    if all_points == 0:
        return float(0)
    
    return float(corr_points) * 100 / all_points


def _calc_feedback_percentage_click(corr, mapping):
    all_points = 0
    corr_points = 0
    page_id = 0
    for cpage, mpage in zip(corr, mapping):
        block_id = 0
        for cblock, mblock in zip(cpage['blocks'], mpage):
            for d in mblock.values():
                for i in range(0, d['len']):
                    all_points += 1
                    check_id = ''
                    if d['direction'] == 0:
                        check_id = 'wordsearch_%d_%d_%d_%d' % (page_id, block_id, d['py'], d['px'] + i)
                    else:
                        check_id = 'wordsearch_%d_%d_%d_%d' % (page_id, block_id, d['py'] + i, d['px'])
                    if check_id in cblock.keys():
                        corr_points += 1
                        continue
                
            
            block_id += 1
        
        page_id += 1
    
    if all_points == 0:
        return float(100)
    
    return float(corr_points) * 100 / all_points


def validate_item_click(request, module_type, **kw):
    level_field = u'_'.join([
        request.ProjectName,
        module_type,
        'level'])
    page_id = int(request.POST['page_id'])
    item_id = request.POST['item_id']
    item_id_splitted = item_id.split('_')
    field_id = int(item_id_splitted[-3])
    row_id = int(item_id_splitted[-2])
    coll_id = int(item_id_splitted[-1])
    level = int(request.session[level_field])
    if level == 1:
        return HttpResponse(simplejson.dumps(dict(item_id = item_id, result = 'WhoCares'), ensure_ascii = False))
    
    
    try:
        return HttpResponse(simplejson.dumps(dict(item_id = item_id, result = wordsearch_fields[page_id][field_id][row_id][coll_id]), ensure_ascii = False))
    except:
        return HttpResponse(simplejson.dumps(dict(item_id = item_id, result = 'WhoCares'), ensure_ascii = False))


validate_item_click = never_cache(validate_item_click)

def validate_item(request, module_type, **kw):
    correct_field = u'_'.join([
        request.ProjectName,
        module_type,
        'correct'])
    block_id = request.POST['block_id']
    page_id = int(request.POST['page_id'])
    value = request.POST['value'].upper()
    block_id_int = int(block_id.split('_')[-1])
    
    try:
        data = wordsearch_mappings[page_id][block_id_int][value]
        correct[page_id]['blocks'][block_id_int][value] = True
        filled_in = 0
        for block in correct[page_id]['blocks']:
            filled_in += len(block.keys())
        
        available = 0
        for block in wordsearch_mappings[page_id]:
            available += len(block.keys())
        
        complete = available == filled_in
        correct[page_id]['complete'] = complete
        request.session[correct_field] = correct
        return HttpResponse(simplejson.dumps(dict(block_id = block_id, result = 'OK', px = data['px'], py = data['py'], orientation = data['direction'], len = data['len'], complete = complete), ensure_ascii = False))
    except Exception:
        {
            'complete': False } if correct_field in request.session else {
            'complete': False }
        e = {
            'complete': False } if correct_field in request.session else {
            'complete': False }
        _[3]
    except:
        []

    return HttpResponse(simplejson.dumps(dict(block_id = block_id, result = 'NoIdea'), ensure_ascii = False))

validate_item = never_cache(validate_item)

def validate_form(request, module_type, **kw):
    correct_field = u'_'.join([
        request.ProjectName,
        module_type,
        'correct'])
    page_id = int(request.POST['page_id'])
    complete = True
    result_items = []
    for block_id_int, block in enumerate(wordsearch_mappings[page_id]):
        block_id = 'wordsearch_%d_%d' % (page_id, block_id_int)
        for k, data in block.iteritems():
            
            try:
                tmp = correct[page_id]['blocks'][block_id_int][k]
                result_items += [
                    dict(block_id = block_id, result = 'OK', px = data['px'], py = data['py'], orientation = data['direction'], len = data['len'])]
            continue
            _[3]
            []
            complete = False
            result_items += [
                dict(block_id = block_id, result = 'WRONG', px = data['px'], py = data['py'], orientation = data['direction'], len = data['len'])]
            continue

        
    
    correct[page_id]['complete'] = complete
    request.session[correct_field] = correct
    return HttpResponse(simplejson.dumps(dict(items = result_items, complete = complete, feedback_percent = _calc_feedback_percentage(correct, wordsearch_mappings)), ensure_ascii = False))

validate_form = never_cache(validate_form)

def validate_form_click(request, module_type, **kw):
    correct_field = u'_'.join([
        request.ProjectName,
        module_type,
        'correct'])
    page_id = int(request.POST['page_id'])
    selected_items = filter((lambda x: x != ''), request.POST['selected_items'].split(','))
    complete = True
    result_items = []
    []['blocks'] = [ { } for block in wordsearch_mappings[page_id] ]
    correct[page_id] = []
    current_fields = [ [ [ cell for cell in row ] for row in field ] for field in wordsearch_fields[page_id] ]
    for selected_item in selected_items:
        selected_item_splitted = selected_item.split('_')
        field_id = int(selected_item_splitted[-3])
        row_id = int(selected_item_splitted[-2])
        col_id = int(selected_item_splitted[-1])
        if current_fields[field_id][row_id][col_id]:
            result_items += [
                dict(item_id = selected_item, result = True)]
            current_fields[field_id][row_id][col_id] = False
            correct[page_id]['blocks'][field_id][selected_item] = True
            continue
        _[7]
        complete = False
        result_items += [
            dict(item_id = selected_item, result = False)]
    
    for field_id, field in enumerate(current_fields):
        for row_id, row in enumerate(field):
            for col_id, cell in enumerate(row):
                if cell:
                    complete = False
                    result_items += [
                        dict(item_id = 'wordsearch_%d_%d_%d_%d' % (page_id, field_id, row_id, col_id), result = False)]
                    continue
                []
            
        
    
    correct[page_id]['complete'] = complete
    request.session[correct_field] = correct
    return HttpResponse(simplejson.dumps(dict(items = result_items, complete = complete, feedback_percent = _calc_feedback_percentage_click(correct, wordsearch_mappings)), ensure_ascii = False))

validate_form_click = never_cache(validate_form_click)

def reset_page(request, module_type, **kw):
    correct_field = u'_'.join([
        request.ProjectName,
        module_type,
        'correct'])
    page_id = int(request.POST['page_id'])
    request.session[correct_field] = correct
    return HttpResponse(simplejson.dumps(dict(result = 'OK'), ensure_ascii = False))

reset_page = never_cache(reset_page)

def reset_page_if_complete(request, module_type, **kw):
    correct_field = u'_'.join([
        request.ProjectName,
        module_type,
        'correct'])
    page_id = int(request.POST['page_id'])
    if correct_field in request.session:
        if page_id < len(request.session[correct_field]):
            if not request.session[correct_field][page_id]['complete']:
                return HttpResponse(simplejson.dumps(dict(result = 'OK'), ensure_ascii = False))
            
        
    
    return reset_page(request, module_type, **kw)

reset_page_if_complete = never_cache(reset_page_if_complete)

def show_help(request, module_type, **kw):
    level_field = u'_'.join([
        request.ProjectName,
        module_type,
        'level'])
    page_id = int(request.POST['page_id'])
    level = int(request.session[level_field])
    items = []
    if level == 3:
        if page_id < len(wordsearch_mappings):
            for block_id_int, block in enumerate(wordsearch_mappings[page_id]):
                block_id = 'wordsearch_%d_%d' % (page_id, block_id_int)
                for k, data in block.iteritems():
                    items += [
                        dict(result = 'POSSIBLE', block_id = block_id, px = data['px'], py = data['py'], orientation = data['direction'], len = data['len'])]
                
            
        
    
    return HttpResponse(simplejson.dumps(dict(items = items), ensure_ascii = False))

show_help = never_cache(show_help)

def show_help(request, module_type, **kw):
    level_field = u'_'.join([
        request.ProjectName,
        module_type,
        'level'])
    page_id = int(request.POST['page_id'])
    level = int(request.session[level_field])
    items = []
    if level == 3:
        if page_id < len(wordsearch_mappings):
            for block_id_int, block in enumerate(wordsearch_mappings[page_id]):
                block_id = 'wordsearch_%d_%d' % (page_id, block_id_int)
                for k, data in block.iteritems():
                    items += [
                        dict(result = 'POSSIBLE', block_id = block_id, px = data['px'], py = data['py'], orientation = data['direction'], len = data['len'])]
                
            
        
    
    return HttpResponse(simplejson.dumps(dict(items = items), ensure_ascii = False))

show_help = never_cache(show_help)

def show_help_click(request, module_type, **kw):
    level_field = u'_'.join([
        request.ProjectName,
        module_type,
        'level'])
    page_id = int(request.POST['page_id'])
    level = int(request.session[level_field])
    items = []
    if level == 3:
        if page_id < len(wordsearch_mappings):
            for block_id_int, block in enumerate(wordsearch_fields[page_id]):
                item_id = 'wordsearch_%d_%d_%s' % (page_id, block_id_int, '%d_%d')
                for row_id, row in enumerate(block):
                    for col_id, cell in enumerate(row):
                        if cell:
                            items += [
                                dict(result = 'POSSIBLE', item_id = item_id % (row_id, col_id))]
                            continue
                    
                
            
        
    
    return HttpResponse(simplejson.dumps(dict(items = items), ensure_ascii = False))

show_help_click = never_cache(show_help_click)

def reset_task(request, module_type, **kw):
    correct_field = u'_'.join([
        request.ProjectName,
        module_type,
        'correct'])
    correct = [ [] for i, page in enumerate(wordsearch_mappings) ]
    request.session[correct_field] = correct
    return HttpResponse(simplejson.dumps(dict(result = 'OK'), ensure_ascii = False))

reset_task = never_cache(reset_task)

def get_correct(request, module_type, **kw):
    correct_field = u'_'.join([
        request.ProjectName,
        module_type,
        'correct'])
    page_id = int(request.POST['page_id'])
    result_items = []
    for block_id_int, block in enumerate(wordsearch_mappings[page_id]):
        block_id = 'wordsearch_%d_%d' % (page_id, block_id_int)
        for k, data in block.iteritems():
            
            try:
                tmp = correct[page_id]['blocks'][block_id_int][k]
                result_items += [
                    dict(block_id = block_id, result = 'OK', px = data['px'], py = data['py'], orientation = data['direction'], len = data['len'])]
            continue
            _[3]
            []
            continue

        
    
    return HttpResponse(simplejson.dumps(dict(items = result_items), ensure_ascii = False))

get_correct = never_cache(get_correct)

def get_correct_click(request, module_type, **kw):
    correct_field = u'_'.join([
        request.ProjectName,
        module_type,
        'correct'])
    page_id = int(request.POST['page_id'])
    result_items = []
    for block in correct[page_id]['blocks']:
        for item in block.keys():
            result_items += [
                dict(item_id = item, result = 'correct')]
        
    
    return HttpResponse(simplejson.dumps(dict(items = result_items, page_id = page_id), ensure_ascii = False))

get_correct_click = never_cache(get_correct_click)
