# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

from django.http import HttpResponse
from django.utils import simplejson
from django.utils.decorators import decorator_from_middleware
from django.contrib.sessions.middleware import SessionMiddleware
import datetime
import os
import logging
from alexandriacore.utils import keys_to_byteString
from django.template import Template, RequestContext
from django.views.decorators.cache import never_cache
from types import ListType, TupleType
destination = 'CD-Rom'
genialmod_unit = 9
genialunit = 9
name = '\xc3\x9cbung 1'
number = 1
container = '9'
editor = 'gapfill'

def dispatch_media(request, module_type, media_id, **kwargs):
    static = request.ProjectSettings.STATIC
    return static.dispatch(request, media_id, key = module_type)

dispatch_media = never_cache(dispatch_media)

def render(request, module_type, **kwargs):
    if kwargs.has_key('exercise_id'):
        key = u'_'.join([
            request.ProjectName,
            kwargs['exercise_id'],
            'lvl'])
        if key in request.session.keys():
            kwargs['level'] = request.session[key]
        else:
            kwargs['level'] = 0
        key = u'_'.join([
            request.ProjectName,
            kwargs['exercise_id'],
            'alt'])
        if key in request.session.keys():
            kwargs['alt'] = request.session[key]
        else:
            kwargs['alt'] = 0
    
    
    try:
        kwargs['levels_available'] = request.session[u'_'.join([
            request.ProjectName,
            module_type,
            'levelcount'])] > 1
    except:
        kwargs['levels_available'] = False

    task_level = 1
    level_field = u'_'.join([
        request.ProjectName,
        module_type,
        'level'])
    type_field = u'_'.join([
        request.ProjectName,
        module_type,
        'type'])
    if level_field in request.session:
        task_level = int(request.session[level_field])
    
    level3_filename = os.path.join(os.path.split(__file__)[0], '..', 'static', request.session[type_field] + '_solution' + '.view')
    if task_level == 3 and os.path.exists(level3_filename):
        filename = level3_filename
    else:
        filename = os.path.join(os.path.split(__file__)[0], '..', 'static', request.session[type_field] + [
            '',
            '_hint'][task_level >= 2] + '.view')
    f = open(filename, 'r')
    result = f.read()
    f.close()
    if not kwargs.has_key('genialmod_unit'):
        kwargs['genialmod_unit'] = genialmod_unit
    
    if not kwargs.has_key('genialunit'):
        kwargs['genialunit'] = genialunit
    
    if not kwargs.has_key('name'):
        kwargs['name'] = name
    
    if not kwargs.has_key('number'):
        kwargs['number'] = number
    
    if not kwargs.has_key('skin'):
        kwargs['skin'] = 'skins/genial'
    
    if not kwargs.has_key('count'):
        kwargs['count'] = 1
    
    return HttpResponse(Template(result).render(RequestContext(request, keys_to_byteString(kwargs))))


def view(request, module_type, **kwargs):
    tmp = kwargs
    nkw = dict()
    for key, value in kwargs.iteritems():
        if isinstance(key, unicode):
            key = key.encode('utf-8')
        
        nkw[key] = value
    
    for key, value in request.GET.iteritems():
        x = value
        if x.upper() == 'TRUE':
            x = True
        elif x.upper() == 'FALSE':
            x = False
        else:
            
            try:
                x = int(x)
            except:
                pass

        if isinstance(key, unicode):
            key = key.encode('utf-8')
        
        nkw[key] = x
    
    nkw['comm_url'] = '../../communication/'
    nkw['feedback_url'] = '../../feedback/'
    return render(request, module_type, **nkw)

view = never_cache(view)
all_dnd_items_on_page = {
    0: [
        '025',
        '023',
        '021',
        '019',
        '009',
        '020',
        '001',
        '017',
        '004',
        '010',
        '003',
        '002',
        '007',
        '022',
        '008',
        '015',
        '027',
        '024'] }
all_dnd_items_on_page_filtered = {
    0: [
        '023',
        '010',
        '019',
        '003',
        '008',
        '027',
        '025',
        '017',
        '022',
        '002'] }
all_dnd_items_on_page_match = {
    0: [
        '023',
        '025',
        '019',
        '010',
        '022',
        '002',
        '003',
        '017',
        '008'] }
all_dnd_items_on_page_no_distractors = {
    0: [
        '002',
        '003',
        '008',
        '010',
        '017',
        '019',
        '022',
        '023',
        '025'] }
corr_mapping_match = {
    0: {
        '003': [
            '008'],
        '002': [
            '003'],
        '001': [
            '002'],
        '007': [
            '022'],
        '006': [
            '019'],
        '005': [
            '017'],
        '004': [
            '010'],
        '009': [
            '025'],
        '008': [
            '023'] } }
corr_mapping = {
    0: {
        '003': [
            '006',
            '008'],
        '002': [
            '005',
            '003'],
        '001': [
            '002'],
        '007': [
            '022'],
        '006': [
            '018',
            '019'],
        '005': [
            '013',
            '012',
            '016',
            '011',
            '014',
            '017'],
        '004': [
            '010'],
        '009': [
            '026',
            '025'],
        '008': [
            '023'] } }
hint_mapping = {
    0: {
        '003': '008',
        '002': '003',
        '001': '002',
        '007': '022',
        '006': '019',
        '005': '017',
        '004': '010',
        '009': '025',
        '008': '023' } }
exclude = [
    ' ',
    '.',
    '!',
    ',',
    "'",
    '?',
    ':',
    '-']

def _calc_feedback_percentage(correct, mapping):
    keys = []
    for page in correct.itervalues():
        for cor in page.iterkeys():
            keys += [
                cor]
        
    
    gaps_all = 0
    gaps_correct = 0
    for p_id, page in mapping.iteritems():
        for k in page.keys():
            gaps_all += 1
            if 'gap_' + k in keys:
                gaps_correct += 1
                continue
        
    
    if gaps_all == 0:
        return float(100)
    
    return float(gaps_correct) * 100 / gaps_all


def validate_id(request, module_type, **kw):
    gap_id = request.POST['gap_id']
    entry_id = request.POST['entry_id']
    tmp_gap_id = gap_id
    entry_id = '%03d' % int(entry_id)
    gap_id = '%03d' % int(gap_id.split('_')[-1])
    page_id = int(request.POST['page_id'])
    level = int(request.session[u'_'.join([
        request.ProjectName,
        module_type,
        'level'])])
    if level == 1:
        return HttpResponse(simplejson.dumps(dict(gap_id = tmp_gap_id, result = 'WhoCares', ensure_ascii = False)))
    
    
    try:
        return HttpResponse(simplejson.dumps(dict(gap_id = tmp_gap_id, result = entry_id in corr_mapping[page_id][gap_id]), ensure_ascii = False))
    except KeyError:
        e = None
        return HttpResponse(simplejson.dumps(dict(gap_id = tmp_gap_id, result = False), ensure_ascii = False))


str_id_mapping = {
    u'Taxi': '023',
    u'Helikopter': '005',
    u'Rad': '018',
    u'U-Bahn': '010',
    u'Schiff': '002',
    u'Hubschrauber': '003',
    u'Omnibus': '006',
    u'Bus': '008',
    u'Automobil': '026',
    u'Intercityexpress': '013',
    u'ICE': '012',
    u'Zug': '017',
    u'............': '001',
    u'Fahrrad': '019',
    u'Auto': '025',
    u'IC': '016',
    u'Intercityzug': '011',
    u'Intercity': '014',
    u'Flugzeug': '022' }

def validate_str(request, module_type, **kw):
    gap_id = request.POST['gap_id']
    entry_str = request.POST['entry_str']
    page_id = int(request.POST['page_id'])
    tmp_gap_id = gap_id
    gap_id = '%03d' % int(gap_id.split('_')[-1])
    level = int(request.session[u'_'.join([
        request.ProjectName,
        module_type,
        'level'])])
    if level == 1:
        return HttpResponse(simplejson.dumps(dict(gap_id = tmp_gap_id, result = 'WhoCares', ensure_ascii = False)))
    
    
    try:
        if not str_id_mapping.has_key(entry_str):
            return HttpResponse(simplejson.dumps(dict(gap_id = tmp_gap_id, result = str_id_mapping[entry_str.strip()] in corr_mapping[page_id][gap_id]), ensure_ascii = False))
        else:
            return HttpResponse(simplejson.dumps(dict(gap_id = tmp_gap_id, result = str_id_mapping[entry_str] in corr_mapping[page_id][gap_id]), ensure_ascii = False))
    except KeyError:
        e = None
        return HttpResponse(simplejson.dumps(dict(gap_id = tmp_gap_id, result = False), ensure_ascii = False))



def evaluate_form_str(request, module_type, **kw):
    result = []
    false_or_missing = False
    page_id = int(request.POST['page_id'])
    correct_field = u'_'.join([
        request.ProjectName,
        module_type,
        'correct'])
    if correct_field in request.session:
        correct = request.session[correct_field]
        if len(correct.keys()) != len(corr_mapping.keys()):
            correct = { }
            for p in corr_mapping.keys():
                correct[p] = { }
            
        
    else:
        correct = { }
        for p in corr_mapping.keys():
            correct[p] = { }
        
    correct[page_id] = { }
    for gap, corr_ids in corr_mapping[page_id].iteritems():
        gap_id = 'gap_%s' % gap
        if gap_id not in request.POST:
            false_or_missing = True
            result += [
                {
                    'id': gap_id,
                    'result': False }]
            continue
        gap_result = False
        
        try:
            if not str_id_mapping.has_key(request.POST[gap_id]):
                mapping = str_id_mapping[request.POST[gap_id].strip()]
            else:
                mapping = str_id_mapping[request.POST[gap_id]]
            gap_result = mapping in corr_ids
            if gap_result:
                correct[page_id][gap_id] = request.POST[gap_id]
        except KeyError:
            e = None

        if not gap_result:
            false_or_missing = True
        
        result += [
            {
                'id': gap_id,
                'result': gap_result }]
    
    request.session[correct_field] = correct
    return HttpResponse(simplejson.dumps(dict(complete = not false_or_missing, results = result, feedback_percent = _calc_feedback_percentage(request.session[correct_field], corr_mapping)), ensure_ascii = False))


def get_correct(request, module_type, **kw):
    result = []
    correct_field = u'_'.join([
        request.ProjectName,
        module_type,
        'correct'])
    if correct_field in request.session.keys():
        tmp = request.session[correct_field]
        for page_id, corr_data in tmp.iteritems():
            p = {
                'p_id': page_id,
                'items': [] }
            for corr_key, corr_value in corr_data.iteritems():
                p['items'] += [
                    {
                        'id': corr_key,
                        'value': corr_value }]
            
            result += [
                p]
        
    
    return HttpResponse(simplejson.dumps(result, ensure_ascii = False))


def evaluate_form_id(request, module_type, **kw):
    result = []
    page_id = int(request.POST['page_id'])
    false_or_missing = False
    correct_field = u'_'.join([
        request.ProjectName,
        module_type,
        'correct'])
    if correct_field in request.session:
        correct = request.session[correct_field]
        if len(correct.keys()) != len(corr_mapping.keys()):
            correct = { }
            for p in corr_mapping.keys():
                correct[p] = { }
            
        
    else:
        correct = { }
        for p in corr_mapping.keys():
            correct[p] = { }
        
    correct[page_id] = { }
    for gap, corr_ids in corr_mapping[page_id].iteritems():
        gap_id = 'gap_%s' % gap
        if gap_id not in request.POST:
            false_or_missing = True
            result += [
                {
                    'id': gap_id,
                    'result': False }]
            continue
        gap_result = False
        
        try:
            if request.POST[gap_id] == '-1':
                gap_result = int(request.POST[gap_id]) in corr_ids
            else:
                gap_result = '%03d' % int(request.POST[gap_id]) in corr_ids
            if gap_result:
                correct[page_id][gap_id] = request.POST[gap_id]
        except KeyError:
            e = None

        if not gap_result:
            false_or_missing = True
        
        result += [
            {
                'id': gap_id,
                'result': gap_result }]
    
    request.session[correct_field] = correct
    return HttpResponse(simplejson.dumps(dict(complete = not false_or_missing, results = result, feedback_percent = _calc_feedback_percentage(request.session[correct_field], corr_mapping)), ensure_ascii = False))


def get_hint_dnd(request, module_type, **kw):
    gap_id = '%03d' % int(request.POST['gap_id'].split('_')[-1])
    page_id = int(request.POST['page_id'])
    
    try:
        level = int(request.session[u'_'.join([
            request.ProjectName,
            module_type,
            'level'])])
    except:
        level = 1

    subtype = request.session[u'_'.join([
        request.ProjectName,
        module_type,
        'type'])]
    if subtype != 'type_dnd' and subtype != 'type_match' or subtype != 'type_dnd2' or level != 3:
        items = []
    else:
        
        try:
            tmp = corr_mapping[page_id][gap_id]
            items = [ ''.join([
                'item_',
                str(x)]) for x in tmp ]
        except Exception:
            e = None
            items = []

    return HttpResponse(simplejson.dumps(dict(items = items, gap_id = request.POST['gap_id']), ensure_ascii = False))


def get_hint_dropdown(request, module_type, **kw):
    gap_id = '%03d' % int(request.POST['gap_id'].split('_')[-1])
    page_id = int(request.POST['page_id'])
    
    try:
        level = int(request.session[u'_'.join([
            request.ProjectName,
            module_type,
            'level'])])
    except:
        level = 1

    subtype = request.session[u'_'.join([
        request.ProjectName,
        module_type,
        'type'])]
    if subtype != 'type_dropdown' or level != 3:
        items = []
    else:
        
        try:
            items = [ '_'.join([
                'gap',
                str(gap_id),
                str(int(res_id))]) for res_id in corr_mapping[page_id][gap_id] ]
        except Exception:
            e = None
            items = []

    return HttpResponse(simplejson.dumps(dict(items = items, gap_id = request.POST['gap_id']), ensure_ascii = False))

full_mapping = {
    u'Taxi': [
        '023'],
    u'Helikopter': [
        '005'],
    u'Rad': [
        '018'],
    u'Automobil': [
        '026'],
    u'Schiff': [
        '002'],
    u'Hubschrauber': [
        '003'],
    u'Omnibus': [
        '006'],
    u'Bus': [
        '008'],
    u'Flugzeug': [
        '022'],
    u'Fahrrad': [
        '019'],
    u'Intercityexpress': [
        '013'],
    u'ICE': [
        '012'],
    u'............': [
        '001',
        '004',
        '007',
        '009',
        '015',
        '020',
        '021',
        '024',
        '027'],
    u'U-Bahn': [
        '010'],
    u'Auto': [
        '025'],
    u'IC': [
        '016'],
    u'Intercityzug': [
        '011'],
    u'Intercity': [
        '014'],
    u'Zug': [
        '017'] }

def get_hint_str(request, module_type, **kw):
    gap_id = '%03d' % int(request.POST['gap_id'].split('_')[-1])
    entry_str = request.POST['entry_str']
    
    try:
        level = int(request.session[u'_'.join([
            request.ProjectName,
            module_type,
            'level'])])
    except:
        level = 1

    subtype = request.session[u'_'.join([
        request.ProjectName,
        module_type,
        'type'])]
    valid = False
    text = ''
    page_id = int(request.POST['page_id'])
    if level in (1, 2):
        if subtype == 'type_underline':
            hint_id = hint_mapping[page_id][gap_id]
            
            try:
                text = ''
                tmp_text = _[1][0]
                for letter in tmp_text:
                    if letter not in exclude:
                        text += '*'
                        continue
                    []
                    text += letter
                
                valid = True
            except Exception:
                e = None
            except:
                None<EXCEPTION MATCH>Exception
            

        None<EXCEPTION MATCH>Exception
        if subtype == 'type_1st':
            hint_id = hint_mapping[page_id][gap_id]
            
            try:
                tmp_text = _[2][0]
                text = tmp_text[0]
                for letter in tmp_text[1:]:
                    if letter not in exclude:
                        text += '*'
                        continue
                    []
                    text += letter
                
                valid = True
            except Exception:
                e = None
            except:
                None<EXCEPTION MATCH>Exception
            

        None<EXCEPTION MATCH>Exception
    elif level == 3:
        if subtype in ('type_1st', 'type_free', 'type_underline'):
            hint_id = hint_mapping[page_id][gap_id]
            
            try:
                text = _[3][0]
                valid = True
            except Exception:
                e = None
            except:
                None<EXCEPTION MATCH>Exception
            

        None<EXCEPTION MATCH>Exception
    
    return HttpResponse(simplejson.dumps(dict(valid = valid, text = text, gap_id = request.POST['gap_id']), ensure_ascii = False))


def internal_migrate_gapfill_dnd(request, module_type, this_level, other_level, play_type):
    correct_field = u'_'.join([
        request.ProjectName,
        module_type,
        'correct'])
    if correct_field not in request.session:
        return 'NOTHING'
    
    if play_type not in ('type_dnd',):
        return 'NOTHING'
    
    if this_level == other_level:
        return 'NOTHING'
    
    if this_level > 1 and other_level > 1:
        return 'NOTHING'
    
    if this_level > 1 and other_level == 1:
        correct = request.session[correct_field]
        new_correct = { }
        for page_id, items in correct.iteritems():
            page_correct = { }
            if play_type == 'type_dnd':
                possible_sources = all_dnd_items_on_page[page_id][:]
            else:
                possible_sources = all_dnd_items_on_page_no_distractors[page_id][:]
            for gap_id, gap_val in items.iteritems():
                if gap_val == '-1':
                    page_correct[gap_id] = gap_val
                    continue
                if gap_val in possible_sources:
                    page_correct[gap_id] = gap_val
                    possible_sources.remove(gap_val)
                    continue
                cm = corr_mapping[page_id][gap_id[4:]]
                for tmp in cm:
                    if tmp in possible_sources:
                        page_correct[gap_id] = tmp
                        possible_sources.remove(tmp)
                        break
                        continue
                
            
            new_correct[page_id] = page_correct
        
        request.session[correct_field] = new_correct
        return 'DONE'
    else:
        correct = request.session[correct_field]
        new_correct = { }
        for page_id, items in correct.iteritems():
            page_correct = { }
            possible_sources = all_dnd_items_on_page_filtered[page_id][:]
            for gap_id, gap_val in items.iteritems():
                cm = corr_mapping[page_id][gap_id[4:]]
                for tmp in cm:
                    if tmp in possible_sources:
                        page_correct[gap_id] = tmp
                        break
                        continue
                
            
            new_correct[page_id] = page_correct
        
        request.session[correct_field] = new_correct
        return 'DONE'


def internal_forcefillin(request, module_type):
    sub_type = request.session[u'_'.join([
        request.ProjectName,
        module_type,
        'type'])]
    level = request.session[u'_'.join([
        request.ProjectName,
        module_type,
        'level'])]
    if not sub_type == 'type_match':
        if sub_type == 'type_dnd' or level > 1 or sub_type == 'type_dnd2':
            correct = { }
            for pageid, pagedata in corr_mapping_match.iteritems():
                corr_page = { }
                for gapid, gapvalues in pagedata.iteritems():
                    corr_page['gap_' + gapid] = gapvalues[0]
                
                correct[pageid] = corr_page
            
            request.session[u'_'.join([
                request.ProjectName,
                module_type,
                'correct'])] = correct
        elif sub_type == 'type_dnd':
            correct = { }
            for pageid, pagedata in corr_mapping.iteritems():
                corr_page = { }
                for gapid, gapvalues in pagedata.iteritems():
                    for gapvalue in gapvalues:
                        if gapvalue in all_dnd_items_on_page_filtered[pageid]:
                            corr_page['gap_' + gapid] = gapvalue
                            break
                            continue
                    
                
                correct[pageid] = corr_page
            
            request.session[u'_'.join([
                request.ProjectName,
                module_type,
                'correct'])] = correct
        elif sub_type == 'type_dropdown':
            correct = { }
            for pageid, pagedata in corr_mapping_match.iteritems():
                corr_page = { }
                for gapid, gapvalues in pagedata.iteritems():
                    corr_page['gap_' + gapid] = int(gapvalues[0])
                
                correct[pageid] = corr_page
            
            request.session[u'_'.join([
                request.ProjectName,
                module_type,
                'correct'])] = correct
        else:
            correct = { }
            for page_id, page in corr_mapping.iteritems():
                corr_page = { }
                for gap_id in page.keys():
                    hint_id = ''
                    
                    try:
                        hint_id = hint_mapping[page_id][gap_id]
                    except:
                        corr_page['gap_' + gap_id] = ''
                        continue

                    tmp_text = _[1][0]
                    corr_page['gap_' + gap_id] = tmp_text
                
                correct[page_id] = corr_page
                request.session[u'_'.join([
                    request.ProjectName,
                    module_type,
                    'correct'])] = correct
            
    return 'OK'

