# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

from django.db import models
from django.conf import settings
from django.utils.translation import ugettext_lazy as _
import cPickle as pickle
import base64
from django.conf import settings
if settings.IS_SBX:
    
    class User(models.Model):
        
        class Meta:
            unique_together = (('project', 'sbxid'),)

        id = models.AutoField(primary_key = True)
        sbxid = models.CharField(max_length = 255)
        username = models.CharField(_('username'), max_length = 255, null = True, blank = True, help_text = _('Required. 255 characters or fewer. Alphanumeric characters only (letters, digits and underscores).'))
        project = models.CharField(max_length = 255)

else:
    
    class User(models.Model):
        
        class Meta:
            unique_together = (('project', 'username'),)

        id = models.AutoField(primary_key = True)
        username = models.CharField(_('username'), max_length = 255, help_text = _('Required. 255 characters or fewer. Alphanumeric characters only (letters, digits and underscores).'))
        project = models.CharField(max_length = 30)


class AbstractUserProfile(models.Model):
    user = models.ForeignKey(User, unique = True)
    viewed_exercises = models.TextField(null = True, default = None)
    finished_exercises = models.TextField(null = True, default = None)
    
    class Meta:
        abstract = True

    
    def get_username(self):
        return self.user.username

    
    def get_viewed_exercises(self):
        if self.viewed_exercises:
            return pickle.loads(base64.decodestring(self.viewed_exercises))
        

    
    def set_viewed_exercises(self, value):
        self.viewed_exercises = base64.encodestring(pickle.dumps(value))

    
    def get_finished_exercises(self):
        if self.finished_exercises:
            return pickle.loads(base64.decodestring(self.finished_exercises))
        

    
    def set_finished_exercises(self, value):
        self.finished_exercises = base64.encodestring(pickle.dumps(value))

    
    def get_finished_exercises_grouped(self, volume):
        ex = self.get_finished_exercises()
        ret = dict()
        if ex:
            for key, value in ex.iteritems():
                if key.startswith('%s_' % volume):
                    block = key.split('_')[1]
                    if ret.has_key(block):
                        ret[block] = ret[block] + value.keys()
                    else:
                        ret[block] = value.keys()
                ret.has_key(block)
            
        
        return ret

    
    def __unicode__(self):
        return u'<UserProfile: %s>' % self.user.username



class AbstractAudioFile(models.Model):
    
    class Meta:
        abstract = True

    user = models.ForeignKey(User)
    filename = models.TextField()
    backgroundsoundurl = models.TextField(blank = True, null = True)
    created = models.DateTimeField(auto_now_add = True)

