# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

from django.template import Library, Node, TextNode
from django.template.loader_tags import ExtendsNode, BlockNode, ConstantIncludeNode, IncludeNode
from django.template import TemplateSyntaxError, TemplateDoesNotExist, Variable
from django.template.loader import get_template_from_string, find_template_source
from alexandriacore.loader import get_template
from django.utils.safestring import mark_safe
from django.template import resolve_variable
from django.conf import settings
register = Library()
if not IS_PLAYER:
    
    class ProjectExtendsNode(ExtendsNode):
        must_be_first = True
        
        def __init__(self, nodelist, parent_name, parent_name_expr, template_dirs = None):
            self.nodelist = nodelist
            self.parent_name = parent_name
            self.parent_name_expr = parent_name_expr
            self.template_dirs = template_dirs

        
        def __repr__(self):
            if self.parent_name_expr:
                return '<ProjectExtendsNode: extends %s>' % self.parent_name_expr.token
            
            return '<ProjectExtendsNode: extends "%s">' % self.parent_name

        
        def get_parent(self, context):
            template_dirs = self.template_dirs
            if template_dirs is None:
                template_dirs = resolve_variable('ProjectTemplateDirs', context)
            
            if self.parent_name_expr:
                self.parent_name = self.parent_name_expr.resolve(context)
            
            parent = self.parent_name
            if not parent:
                error_msg = "Invalid template name in 'extends' tag: %r." % parent
                if self.parent_name_expr:
                    error_msg += " Got this from the '%s' variable." % self.parent_name_expr.token
                
                raise TemplateSyntaxError, error_msg
            
            if hasattr(parent, 'render'):
                return parent
            
            
            try:
                (source, origin) = find_template_source(parent, template_dirs)
            except TemplateDoesNotExist:
                raise TemplateSyntaxError, "Template %r cannot be extended, because it doesn't exist" % parent

            return get_template_from_string(source, origin, parent)

        
        def render(self, context):
            compiled_parent = self.get_parent(context)
            parent_blocks = []([ (n.name, n) for n in compiled_parent.nodelist.get_nodes_by_type(BlockNode) ])
            for block_node in self.nodelist.get_nodes_by_type(BlockNode):
                
                try:
                    parent_block = parent_blocks[block_node.name]
                except KeyError:
                    []
                    []
                    dict
                    for node in compiled_parent.nodelist:
                        if not isinstance(node, TextNode):
                            if isinstance(node, ExtendsNode):
                                node.nodelist.append(block_node)
                            
                            break
                            continue
                    

                parent_block.parent = block_node.parent
                parent_block.add_parent(parent_block.nodelist)
                parent_block.nodelist = block_node.nodelist
            
            return compiled_parent.render(context)


    
    def do_projectextends(parser, token):
        '''
        Signal that this template extends a parent template.
    
        This tag may be used in two ways: ``{% extends "base" %}`` (with quotes)
        uses the literal value "base" as the name of the parent template to extend,
        or ``{% extends variable %}`` uses the value of ``variable`` as either the
        name of the parent template to extend (if it evaluates to a string) or as
        the parent tempate itelf (if it evaluates to a Template object).
        '''
        bits = token.contents.split()
        if len(bits) != 2:
            raise TemplateSyntaxError, "'%s' takes one argument" % bits[0]
        
        (parent_name, parent_name_expr) = (None, None)
        if bits[1][0] in ('"', "'") and bits[1][-1] == bits[1][0]:
            parent_name = bits[1][1:-1]
        else:
            parent_name_expr = parser.compile_filter(bits[1])
        nodelist = parser.parse()
        if nodelist.get_nodes_by_type(ExtendsNode):
            raise TemplateSyntaxError, "'%s' cannot appear more than once in the same template" % bits[0]
        
        return ProjectExtendsNode(nodelist, parent_name, parent_name_expr)

    
    class ProjectConstantIncludeNode(ConstantIncludeNode):
        
        def __init__(self, template_path):
            self.template_path = template_path
            self.firstrun = True

        
        def render(self, context):
            if self.firstrun:
                
                try:
                    template_dirs = resolve_variable('ProjectTemplateDirs', context)
                    t = get_template(self.template_path, template_dirs)
                    self.template = t
                if settings.TEMPLATE_DEBUG:
                    raise 
                

                self.template = None
            
            self.firstrun
            if self.template:
                return self.template.render(context)
            else:
                return ''


    
    class ProjectIncludeNode(IncludeNode):
        
        def __init__(self, template_name):
            self.template_name = Variable(template_name)

        
        def render(self, context):
            
            try:
                template_name = self.template_name.resolve(context)
                template_dirs = resolve_variable('ProjectTemplateDirs', context)
                t = get_template(template_name, template_dirs)
                return t.render(context)
            except TemplateSyntaxError:
                e = None
                if settings.TEMPLATE_DEBUG:
                    raise 
                
                return ''
            except:
                return ''



    
    def do_projectinclude(parser, token):
        '''
        Loads a template and renders it with the current context.
    
        Example::
    
            {% include "foo/some_include" %}
        '''
        bits = token.contents.split()
        if len(bits) != 2:
            raise TemplateSyntaxError, '%r tag takes one argument: the name of the template to be included' % bits[0]
        
        path = bits[1]
        if path[0] in ('"', "'") and path[-1] == path[0]:
            return ProjectConstantIncludeNode(path[1:-1])
        
        return ProjectIncludeNode(bits[1])

    register.tag('projectextends', do_projectextends)
    register.tag('projectinclude', do_projectinclude)
else:
    from django.template.loader_tags import do_extends, do_include
    register.tag('projectextends', do_extends)
    register.tag('projectinclude', do_include)
