# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

from django.db import models
from django.conf import settings
EX_TYPE_COMPULSORY = 0
EX_TYPE_BONUS = 1
EX_TYPE_CHECK = 2
EX_TYP_CHOICES = ((EX_TYPE_COMPULSORY, 'Pflicht'), (EX_TYPE_BONUS, 'Bonus'), (EX_TYPE_CHECK, 'Check'))
APPROVAL_CHOICES = ((0, 'Not approved'), (1, 'Approved'), (2, 'Production'))

def decease_all_tasks():
    connection = connection
    import django.db
    cursor = connection.cursor()
    cursor.execute('UPDATE manifest_task SET deceased=True')


def decease_all_workflow_tasks():
    connection = connection
    import django.db
    cursor = connection.cursor()
    cursor.execute('UPDATE manifest_workflowtask SET deceased=True')


class Mode(models.Model):
    id = models.CharField(max_length = 30, primary_key = True, unique = True)
    name = models.CharField(max_length = 100)
    
    class Meta:
        ordering = [
            'name']

    
    class Admin:
        list_display = ('id', 'name')

    
    def __unicode__(self):
        return u'%s (%s)' % (self.name, self.id)



class Type(models.Model):
    id = models.AutoField(primary_key = True, unique = True)
    name = models.CharField(max_length = 50, unique = True)
    
    class Meta:
        ordering = [
            'name']

    
    class Admin:
        list_display = ('name',)

    
    def __unicode__(self):
        return u'%s' % self.name



class AbstractTask(models.Model):
    id = models.AutoField(primary_key = True, unique = True)
    name = models.CharField(max_length = 200)
    destination = models.CharField(max_length = 50)
    type = models.ForeignKey(Type, null = True)
    approved = models.IntegerField(choices = APPROVAL_CHOICES, default = 0)
    deceased = models.BooleanField(default = False)
    modes = models.ManyToManyField(Mode)
    default_mode = models.ForeignKey(Mode, related_name = '%s(class)_default_for', null = True)
    
    class Meta:
        abstract = True

    
    def __unicode__(self):
        return u'Task %04d (%s) - %s' % (int(self.id), self.type, self.name)



class CanDo(models.Model):
    
    class Admin:
        pass

    id = models.IntegerField(primary_key = True, unique = True)
    project = models.TextField()
    
    class Meta:
        ordering = [
            'id']



class AbstractExercise(models.Model):
    id = models.IntegerField(primary_key = True, unique = True)
    name = models.CharField(max_length = 200)
    number = models.IntegerField(default = 1)
    destination = models.CharField(max_length = 50)
    approved = models.IntegerField(choices = APPROVAL_CHOICES, default = 0)
    portfolio = models.BooleanField(default = False)
    cando = models.ManyToManyField(CanDo, blank = True, null = True)
    showfeedback = models.BooleanField(default = True)
    typ = models.IntegerField(choices = EX_TYP_CHOICES, default = 0)
    
    class Meta:
        abstract = True

    
    def __unicode__(self):
        return u'Exercise %04d' % int(self.id)

    
    def simple_sanity_check(cls):
        return Exercise.objects.count() > 0

    simple_sanity_check = classmethod(simple_sanity_check)

