# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

from alexandriacore.shortcuts import render_to_response
from django.template import RequestContext
from django.http import Http404, HttpResponse, HttpResponseRedirect
from django.views.decorators.cache import never_cache
from django.template import Context
from alexandriacore import loader
from models import AudioFile, Exercise, EX_TYPE_COMPULSORY, EX_TYPE_BONUS, EX_TYPE_CHECK
from django.utils import simplejson
from alexandriacore.exercisebase import remove_exercise_keys
import logging
import copy
from collector.models import User
from alexandriacore import player_recorder
import os.path as ospath
import urllib

def normjoin(*args):
    return ospath.normpath(ospath.join(*args))

unit_list = [
    dict(number = '1', title = 'Sprachen', real = 1),
    dict(number = '2', title = 'Jugend forscht', real = 2),
    dict(number = '3', title = 'Alles, was ich liebe', real = 3),
    dict(number = '4', title = 'Sonne und Wind', real = 4),
    dict(number = '', title = 'Plateau 1', real = 11),
    dict(number = '5', title = 'Kaufen', real = 5),
    dict(number = '6', title = 'Geschichte', real = 6),
    dict(number = '7', title = 'Reisen', real = 7),
    dict(number = '8', title = 'Berufe', real = 8),
    dict(number = '', title = 'Plateau 2', real = 12),
    dict(number = '9', title = 'Mobilit\xc3\xa4t', real = 9),
    dict(number = '10', title = 'Computerwelten', real = 10),
    dict(number = '', title = 'Plateau 3', real = 13)]
unit_ranges = {
    'A': range(1, 5),
    'B': range(5, 9),
    'C': range(9, 13),
    'D': range(13, 17),
    'E': range(17, 21),
    'F': range(21, 25) }
done_dict = {
    'A': 'false',
    'B': 'false',
    'C': 'false',
    'D': 'false',
    'E': 'false',
    'F': 'false' }
loginskin = 'skins/login'

def _fetch_template(dirs, skin, template, default):
    skin = '/'.join(skin.split('/')[1:])
    
    try:
        template = loader.get_template(skin + '/' + template, dirs = dirs)
    except:
        template = loader.get_template(default, dirs)

    return template


def view(request, exercise_id, prefix):
    
    try:
        exercise = Exercise.objects.get(id = int(exercise_id))
    except:
        return render_to_response('cdview/preview_exercise_not_found.html', RequestContext(request, dict(skin = request.ProjectSettings.DEFAULT_SKIN)))

    exercise_list = list(Exercise.objects.filter(destination__exact = exercise.destination, genialunit__exact = exercise.genialunit))
    exercise_count = len(exercise_list)
    number = exercise_list.index(exercise) + 1
    if number == exercise_count:
        next = ''
    else:
        next_exercise = exercise_list[number]
        next = '/'.join([
            prefix,
            '%s' % next_exercise.genialunit,
            'view',
            '%04d' % next_exercise.id])
    if number == 1:
        prev = ''
    else:
        prev_exercise = exercise_list[number - 2]
        prev = '/'.join([
            prefix,
            '%s' % prev_exercise.genialunit,
            'view',
            '%04d' % prev_exercise.id])
    settings = settings
    import django.conf
    if settings.IS_EDITOR:
        help_pref = ''
    else:
        help_pref = 'externalfile:%s' % normjoin(ospath.split(__file__)[0], '..').replace(ospath.sep, '/')
    params = dict(prefix = prefix, eunit = exercise.genialunit, eid = exercise_id, count = exercise_count, is_preview = 'true', number = number, next = next, prev = prev, help_pref = help_pref)
    return HttpResponseRedirect('%(prefix)s/%(eunit)s/exercise_%(eid)s/view?count=%(count)d&is_preview=%(is_preview)s&number=%(number)d&prev=%(prev)s&next=%(next)s&gnext=%(next)s&help_pref=%(help_pref)s' % params)

view = never_cache(view)

def units(request, prefix):
    remove_exercise_keys(request)
    skin = request.ProjectSettings.DEFAULT_SKIN
    user_name_field = request.ProjectName + '_user_name'
    if user_name_field in request.session:
        if request.session[user_name_field] == 'USER':
            return HttpResponseRedirect('%s/login/' % prefix)
        
    else:
        return HttpResponseRedirect('%s/login/' % prefix)
    profile = request.ProjectSettings.get_pupil_profile(request)
    settings = settings
    import django.conf
    if settings.IS_EDITOR:
        help_pref = ''
    else:
        help_pref = 'externalfile:%s' % normjoin(ospath.split(__file__)[0], '..').replace(ospath.sep, '/')
    units = [ i for i in range(1, 11) ]
    plateaus = [ i for i in range(11, 14) ]
    return render_to_response('cdview/units.html', RequestContext(request, dict(units = units, plateaus = plateaus, skin = skin, IS_EDITOR = settings.IS_EDITOR, help_pref = help_pref)))

units = never_cache(units)

def progress(request, prefix, unit):
    remove_exercise_keys(request)
    profile = request.ProjectSettings.get_pupil_profile(request)
    finished = profile.get_finished_exercises()
    if not finished:
        finished = { }
    
    current_unit = unit
    units = copy.deepcopy(unit_list)
    for unit in units:
        if finished.has_key(str(unit['real'])):
            finished_exercises = finished[str(unit['real'])]
        else:
            finished_exercises = { }
        exercises = []
        sum_percent = 0
        for exercise in Exercise.objects.filter(genialunit = unit['real']):
            if finished_exercises.has_key('exercise_%04d' % exercise.id):
                percent = int(round(finished_exercises['exercise_%04d' % exercise.id]['percent']))
                sum_percent += percent
                exercises.append((exercise, dict(percent = percent, divpercent = [
                    'x'] * int(round(float(percent) / 5)))))
                continue
            exercises.append((exercise, dict(percent = 0, divpercent = [])))
        
        unit['exercises'] = exercises
        
        try:
            percent = int(round(float(sum_percent) / len(exercises)))
            unit['percent'] = percent
            unit['divpercent'] = [
                'x'] * int(round(float(percent) / 5))
        except:
            unit['percent'] = 0
            unit['divpercent'] = []

        unit['prefix'] = '%s/%d/view' % (prefix, int(current_unit))
        unit['open'] = int(current_unit) == unit['real']
    
    skin = request.ProjectSettings.DEFAULT_SKIN
    settings = settings
    import django.conf
    if settings.IS_EDITOR:
        help_pref = ''
    else:
        help_pref = 'externalfile:%s' % normjoin(ospath.split(__file__)[0], '..').replace(ospath.sep, '/')
    return render_to_response('cdview/progress.html', RequestContext(request, dict(units = units, current_unit = current_unit, skin = skin, help_pref = help_pref)))

progress = never_cache(progress)

def load_profile(request, prefix):
    save_name(request, prefix)
    return HttpResponseRedirect('%s/' % prefix)


def delete_profile(request, prefix):
    username = request.REQUEST['username']
    request.ProjectSettings.remove_pupil(request, username)
    return HttpResponseRedirect('%s/login/' % prefix)


def save_name(request, prefix):
    
    try:
        user_name_field = request.ProjectName + '_user_name'
        visit_field = request.ProjectName + '_visit'
        viewed_exercises_field = request.ProjectName + '_viewed_exercises'
        finished_exercises_field = request.ProjectName + '_finished_exercises'
        if user_name_field in request.session:
            del request.session[user_name_field]
        
        if not request.ProjectSettings.login_pupil(request, request.REQUEST['username']):
            return HttpResponse(simplejson.dumps(dict(result = 'FAILED'), ensure_ascii = False), mimetype = 'application/json')
        
        request.session[user_name_field] = request.REQUEST['username']
        profile = request.ProjectSettings.get_pupil_profile(request)
        request.session[viewed_exercises_field] = profile.get_viewed_exercises()
        if not request.session[viewed_exercises_field]:
            request.session[viewed_exercises_field] = { }
        
        request.session[finished_exercises_field] = profile.get_finished_exercises()
        if not request.session[finished_exercises_field]:
            request.session[finished_exercises_field] = { }
        
        return HttpResponse('')
    except Exception:
        e = None
        print e



def command(request, exercise_id, step, command, prefix):
    kw = dict(keep_module_type = True, module_type = 'exercise_%04d' % int(exercise_id), command = 'task_command', step = step, subcommand = command)
    return request.ProjectSettings.EXERCISES.dispatch(request, **kw)


def restart(request, prefix):
    request.session[request.ProjectName + '_user_name'] = 'USER'
    request.session[request.ProjectName + '_viewed_exercises'] = { }
    request.session[request.ProjectName + '_finished_exercises'] = { }
    return HttpResponseRedirect(prefix)


def new_user(request, prefix):
    if request.method == 'POST':
        save_name(request, prefix)
        return HttpResponseRedirect('%s/' % prefix)
    
    return render_to_response('cdview/new.html', RequestContext(request, dict(skin = loginskin)))

new_user = never_cache(new_user)

def login(request, prefix):
    users = User.objects.filter(project = request.ProjectName)
    return render_to_response('cdview/login.html', RequestContext(request, dict(skin = loginskin, users = users)))

login = never_cache(login)

def logout(request, prefix):
    user_name_field = request.ProjectName + '_user_name'
    if user_name_field in request.session:
        del request.session[user_name_field]
    
    return HttpResponseRedirect('%s/' % prefix)

logout = never_cache(logout)

def impressum(request, prefix):
    return render_to_response('cdview/impressum.html', RequestContext(request, dict(skin = loginskin)))

impressum = never_cache(impressum)

def quellennachweis(request, prefix):
    return render_to_response('cdview/quellennachweis.html', RequestContext(request, dict(skin = loginskin)))

quellennachweis = never_cache(quellennachweis)
